%define name 	mysql
%define ver  	3.20.32a
%define rel 	1
%define prefix	/usr

Summary: MySQL database
Name: %{name}
Version: %{ver}
Release: %{rel}
Copyright: GPL
Group: Applications/Databases
Source: http://http://www.tcx.se/mysql-3.20.32a.tar.gz
Source1: mysql.logrotate
Source2: mysql-init-db
URL: http://http://www.tcx.se/
Patch0: mysql-3.20.32a-linux.patch
Patch1: redhat.patch
Patch2: makefile-madness.patch
PreReq: chkconfig
Requires: libtermcap readline
Buildroot: /var/tmp/%{name}-%{ver}root
Exclusivearch: i386 alpha

%description
Mysql is a SQL (Structured Query Language) database server. Mysql was written
by Michael (monty) Widenius. See the CREDITS file in the distribution for more
credits for mysql and related things.

%package -n mysql-bench
Summary: Mysql - Benchmarks
Group: Applications/Databases
Release: %{rel}
Requires: mysql perl mysql-perl
%description -n mysql-bench
Mysql is a SQL (Structured Query Language) database server. Mysql was written
by Michael (monty) Widenius. See the CREDITS file in the distribution for more
credits for mysql and related things.

This package contains Mysql benchmark scripts and data.

%package -n mysql-devel
Summary: Mysql - Perl Module and mysqlaccess script
Group: Development/Libraries
Release: %{rel}
Requires: perl mysql = 3.20.32a
%description -n mysql-devel
Mysql is a SQL (Structured Query Language) database server. Mysql was written
by Michael (monty) Widenius. See the CREDITS file in the distribution for more
credits for mysql and related things.

This package contains the development header files and libraries necessary to
develop client applications.

%package -n mysql-perl
Summary: Mysql - Perl Modules
Group: Applications/Databases
Release: %{rel}
Requires: perl mysql = 3.20.32a
%description -n mysql-perl
Mysql is a SQL (Structured Query Language) database server. Mysql was written
by Michael (monty) Widenius. See the CREDITS file in the distribution for more
credits for mysql and related things.

This package contains the Mysql Perl Modules.

%package -n mysql-client
Summary: Mysql - Client
Group: Applications/Databases
Release: %{rel}
%description -n mysql-client
Mysql is a SQL (Structured Query Language) database server. Mysql was written
by Michael (monty) Widenius. See the CREDITS file in the distribution for more
credits for mysql and related things.

This package contains just the mysql client.

%prep
%setup -q -n %{name}-%{ver}
%patch0 -p1 -b .blah
%patch1 -p1 -b .tim
%patch2 -p1 -b .sheesh

%build
CFLAGS="$RPM_OPT_FLAGS -D_LINUX_TYPES_H" CXX=gcc \
CXXFLAGS="$RPM_OPT_FLAGS -D_LINUX_TYPES_H" LDFLAGS=-s ./configure \
	--without-debug \
	--without-readline \
	--enable-shared \
	--with-unix-socket-path=/var/lib/mysql/mysql.sock \
	--prefix=/ \
	--exec-prefix=/usr \
	--libexecdir=/usr/sbin \
	--bindir=/usr/bin \
	--sbindir=/usr/sbin \
	--infodir=/usr/info \
	--sysconfdir=/etc \
	--datadir=/usr/share \
	--mandir=/usr/man \
	--localstatedir=/var/lib/mysql \
	--includedir=/usr/include \
	--libdir=/usr/lib
make

%install
rm -rf $RPM_BUILD_ROOT
for I in etc/{logrotate.d,profile.d,rc.d/init.d} var/lib/mysql \
	usr/{lib/perl5/%{runarch}-linux/%{perldir},man/man1} usr/info ; do
	mkdir -p $RPM_BUILD_ROOT/$I
done

make	prefix=$RPM_BUILD_ROOT \
	exec-prefix=$RPM_BUILD_ROOT/usr \
	libexecdir=$RPM_BUILD_ROOT/usr/sbin \
	infodir=$RPM_BUILD_ROOT/usr/info \
	sysconfdir=$RPM_BUILD_ROOT/etc \
	datadir=$RPM_BUILD_ROOT/usr/share \
	mandir=$RPM_BUILD_ROOT/usr/man \
	localstatedir=$RPM_BUILD_ROOT/var/lib/mysql \
	includedir=$RPM_BUILD_ROOT/usr/include \
	bindir=$RPM_BUILD_ROOT/usr/bin \
	sbindir=$RPM_BUILD_ROOT/usr/sbin \
	libdir=$RPM_BUILD_ROOT/usr/lib \
	benchdir=$RPM_BUILD_ROOT/var/lib/sql-bench \
	PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALLMAN1DIR=$RPM_BUILD_ROOT/usr/man/man1 \
	install-strip

%ifarch i386
%define runarch i386
%endif

%ifarch sparc
%define runarch sparc
%endif

%ifarch alpha
%define runarch alpha
%endif

mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d/rc0.d

install $RPM_BUILD_ROOT/usr/bin/mysql.server $RPM_BUILD_ROOT/etc/rc.d/init.d/mysql
install -m644 $RPM_SOURCE_DIR/mysql.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/mysql
install -m644 $RPM_SOURCE_DIR/mysql-init-db $RPM_BUILD_ROOT/var/lib/mysql/mysql-db.init

(cd $RPM_BUILD_ROOT/usr/lib; ln -sf libmysqlclient.so.3.20.32a libmysqlclient.so.4)
(cd $RPM_BUILD_ROOT/usr/lib/perl5/site_perl; ln -sf 5.005/%{runarch}-linux/auto/Mysql/Mysql.so Mysql.so)

strip $RPM_BUILD_ROOT/usr/lib/* || :

DIR=$RPM_BUILD_ROOT/usr/


%post
/sbin/ldconfig
if [ ! -d /var/lib/mysql/mysql ]; then
   /usr/sbin/mysqld -Sg -l >/dev/null 2>&1 &
   sleep 1
   mysqladmin create mysql
   mysql mysql < /var/lib/mysql/mysql-db.init
   mysqladmin create test
   mysqladmin shutdown
fi
(cd /etc/rc.d/rc0.d; ln -sf ../init.d/mysql K98mysql)
(cd /etc/rc.d/rc3.d; ln -sf ../init.d/mysql S98mysql)
(cd /etc/rc.d/rc3.d; ln -sf ../init.d/mysql K98mysql)
(cd /etc/rc.d/rc5.d; ln -sf ../init.d/mysql K98mysql)
(cd /etc/rc.d/rc5.d; ln -sf ../init.d/mysql S98mysql)
(cd /etc/rc.d/rc6.d; ln -sf ../init.d/mysql K98mysql)
/etc/rc.d/init.d/mysql start >/dev/null 2>&1

%pre
if [ -x /usr/bin/mysqladmin ]; then
  if mysqladmin status >/dev/null 2>&1; then
   /etc/rc.d/init.d/mysql stop;
  fi
fi

%preun
if [ -x /usr/bin/mysqladmin ]; then
  if mysqladmin status >/dev/null 2>&1; then
   /etc/rc.d/init.d/mysql stop;
  fi
fi
rm -f /etc/rc.d/rc*.d/*mysql

%postun
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%doc NEWS BUGS FAQs/mysql-faq_toc.html FAQs/mysql-faq.html FAQs/mysql-faq.txt
%doc PUBLIC README TODO
/etc/logrotate.d/mysql
/etc/rc.d/init.d/mysql
/usr/bin/mysqlaccess
/usr/bin/comp_err
/usr/bin/isamchk
/usr/bin/isamlog
/usr/bin/msql2mysql
/usr/bin/mysql
/usr/bin/mysql_install_db
/usr/bin/mysqladmin
/usr/bin/mysqlbug
/usr/bin/mysqldump
/usr/bin/mysqlshow
/usr/bin/perror
/usr/bin/replace
/usr/bin/safe_mysqld
/usr/bin/which1
/usr/bin/zap
/usr/sbin/mysqld
%dir /var/lib/mysql
/var/lib/mysql/mysql-db.init
%dir /usr/share/mysql
/usr/share/mysql/czech
/usr/share/mysql/dutch
/usr/share/mysql/english
/usr/share/mysql/french
/usr/share/mysql/germany
/usr/share/mysql/norwegian
/usr/share/mysql/norwegian-ny
/usr/share/mysql/polish
/usr/share/mysql/portuguese
/usr/share/mysql/russian
/usr/share/mysql/spanish
/usr/share/mysql/swedish
/usr/lib/libmysqlclient.so
/usr/lib/libmysqlclient.so.3.20.32a

%files -n mysql-bench
%defattr(-,root,root)
%doc bench/Overview-paper
%doc bench/README
%dir /var/lib/mysql-bench/Results
%dir /var/lib/mysql-bench/data-Wisconsin
%dir /var/lib/mysql-bench/data-ATIS
%dir /var/lib/mysql-bench
/var/lib/mysql-bench/run-all-tests
/var/lib/mysql-bench/test-ATIS
/var/lib/mysql-bench/test-big-tables
/var/lib/mysql-bench/test-connect
/var/lib/mysql-bench/test-create
/var/lib/mysql-bench/test-insert
/var/lib/mysql-bench/test-select
/var/lib/mysql-bench/wisconsin-test
/var/lib/mysql-bench/data-ATIS/*
/var/lib/mysql-bench/data-Wisconsin/*

%files -n mysql-devel
%defattr(-,root,root)
/usr/lib/mysql/*.a
/usr/include/mysql/*.h
%dir /usr/lib/mysql
%dir /usr/include/mysql

%files -n mysql-perl 
%defattr(-,root,root)
/usr/lib/perl5/site_perl/5.005/*-linux/auto/Mysql/.packlist
/usr/lib/perl5/site_perl/5.005/*-linux/auto/Mysql/Mysql.so
/usr/lib/perl5/site_perl/5.005/*-linux/auto/Mysql/Mysql.bs
/usr/lib/perl5/site_perl/5.005/*-linux/Mysql/Statement.pm
/usr/lib/perl5/site_perl/5.005/*-linux/Mysql.pm
/usr/lib/perl5/man/man3/Mysql.3
/usr/lib/perl5/site_perl/Mysql.so

%files -n mysql-client
%defattr(-,root,root)
/usr/bin/mysql
/usr/bin/mysqlshow
/usr/lib/libmysqlclient.so
/usr/lib/libmysqlclient.so.3.20.32a
/usr/lib/libmysqlclient.so.4

%changelog
* Tue Aug 31 1999 Tim Powers <timp@redhat.com>
- created patch to get things building with glibc 2.1
- created specfile from the one located at http://www.tcx.se/, the origional
  spec file didn't "do the right thing", so it had been modified heavily
- first build for Powertools

